{+-----------------------------------------------------------------------------+
 | Created:     16.12.98
 | Last change: 16.12.98
 | Author:      Primoz Gabrijelcic
 | Description: One unit to bind them - common Register for all mwEdit
 |              components
 | Version:     0.11
 | Copyright (c) 1998 Primoz Gabrijelcic
 | No rights reserved.
 |
 | Thanks to: Brad Stowers
 |
 | Version history:
 |   0.1: first version
 |   0.11: 16.12.1998
 |     - Brad Stowers: customised Font editor
 |
 +----------------------------------------------------------------------------+}


unit mwEditReg;

interface

procedure Register;

implementation

{begin}                                                         //bds 12/16/1998
uses
  DsgnIntf, Dialogs, Forms, Graphics,
  mwCustomEdit, mwPasSyn, DcjCppSyn;

type
  TmwEditorFontProperty = class(TFontProperty)
  public
    procedure Edit; override;
  end;

procedure TmwEditorFontProperty.Edit;
const
  { context ids for the Font editor }
  hcDFontEditor = 25000;
var
  FontDialog: TFontDialog;
begin
  FontDialog := TFontDialog.Create(Application);
  try
    FontDialog.Font := TFont(GetOrdValue);
    FontDialog.HelpContext := hcDFontEditor;
    FontDialog.Options := FontDialog.Options + [fdShowHelp, fdForceFontExist,
       fdFixedPitchOnly];
    if FontDialog.Execute then
      SetOrdValue(Longint(FontDialog.Font));
  finally
    FontDialog.Free;
  end;
end;
{end}                                                           //bds 12/16/1998

procedure Register;
begin
  mwCustomEdit.Register;
  RegisterPropertyEditor(TypeInfo(TFont), TmwCustomEdit,        //bds 12/16/1998
     'Font', TmwEditorFontProperty);
  mwPasSyn.Register;
  DcjCppSyn.Register;
end; { Register }

end.
